<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <title>uWeaver UI - API documentation : Source: widget/Filebox.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link href="styles/bootstrap.css" rel="stylesheet">
    <link href="styles/docs.css" rel="stylesheet">
    <link href="styles/bootstrap-custom.css" rel="stylesheet">
    <link href="http://netdna.bootstrapcdn.com/font-awesome/3.2.1/css/font-awesome.css" rel="stylesheet">
    <script src="http://netdna.bootstrapcdn.com/twitter-bootstrap/2.3.2/js/bootstrap.min.js"></script>
  </head>
  <body>
    <header class="header navbar navbar-inverse">
      <div class="navbar-inner">
        <div class="container-fluid">
          <a class="brand" href="#"><strong>uWeaver UI</strong> API documentation</a>
        </div>
      </div>
    </header>

    <div class="container-fluid">
      <div class="row-fluid">
          <div class="span4">
              <h2><a href="index.html">Index</a></h2><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Modules</li><li><a href="module-boolean.html">boolean</a></li>
<li><a href="module-datetime.html">datetime</a></li>
<li><a href="module-dom.html">dom</a></li>
<li><a href="module-environment.html">environment</a></li>
<li><a href="module-formatter.html">formatter</a></li>
<li><a href="module-i18n.html">i18n</a></li>
<li><a href="module-lang.html">lang</a></li>
<li><a href="module-net.html">net</a></li>
<li><a href="module-number.html">number</a></li>
<li><a href="module-uweaver.html">uweaver</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Classes</li><li><a href="Activities.html"><i class="icon-shield" style="color: #0186d1"></i> Activities</a></li><li><a href="Activity.html"><i class="icon-shield" style="color: #0186d1"></i> Activity</a></li><li><a href="Applet.html"><i class="icon-shield" style="color: #0186d1"></i> Applet</a></li><li><a href="BaseObject.html"><i class="icon-shield" style="color: #0186d1"></i> BaseObject</a></li><li><a href="Button.html"><i class="icon-shield" style="color: #0186d1"></i> Button</a></li><li><a href="CartesianChart.html"><i class="icon-shield" style="color: #0186d1"></i> CartesianChart</a></li><li><a href="Checkbox.html"><i class="icon-shield" style="color: #0186d1"></i> Checkbox</a></li><li><a href="Collection.html"><i class="icon-shield" style="color: #0186d1"></i> Collection</a></li><li><a href="Combobox.html"><i class="icon-shield" style="color: #0186d1"></i> Combobox</a></li><li><a href="Container.html"><i class="icon-shield" style="color: #0186d1"></i> Container</a></li><li><a href="Datebox.html"><i class="icon-shield" style="color: #0186d1"></i> Datebox</a></li><li><a href="Datepicker.html"><i class="icon-shield" style="color: #0186d1"></i> Datepicker</a></li><li><a href="Filebox.html"><i class="icon-shield" style="color: #0186d1"></i> Filebox</a></li><li><a href="Filedropper.html"><i class="icon-shield" style="color: #0186d1"></i> Filedropper</a></li><li><a href="Form.html"><i class="icon-shield" style="color: #0186d1"></i> Form</a></li><li><a href="Gadget.html"><i class="icon-shield" style="color: #0186d1"></i> Gadget</a></li><li><a href="Grid.html"><i class="icon-shield" style="color: #0186d1"></i> Grid</a></li><li><a href="Icon.html"><i class="icon-shield" style="color: #0186d1"></i> Icon</a></li><li><a href="Inputbox.html"><i class="icon-shield" style="color: #0186d1"></i> Inputbox</a></li><li><a href="Item.html"><i class="icon-shield" style="color: #0186d1"></i> Item</a></li><li><a href="Json.html"><i class="icon-shield" style="color: #0186d1"></i> Json</a></li><li><a href="Logger.html"><i class="icon-shield" style="color: #0186d1"></i> Logger</a></li><li><a href="MDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> MDIApplet</a></li><li><a href="Memory.html"><i class="icon-shield" style="color: #0186d1"></i> Memory</a></li><li><a href="Menu.html"><i class="icon-shield" style="color: #0186d1"></i> Menu</a></li><li><a href="Model.html"><i class="icon-shield" style="color: #0186d1"></i> Model</a></li><li><a href="Numberbox.html"><i class="icon-shield" style="color: #0186d1"></i> Numberbox</a></li><li><a href="Pagination.html"><i class="icon-shield" style="color: #0186d1"></i> Pagination</a></li><li><a href="Panel.html"><i class="icon-shield" style="color: #0186d1"></i> Panel</a></li><li><a href="PolarChart.html"><i class="icon-shield" style="color: #0186d1"></i> PolarChart</a></li><li><a href="Popup.html"><i class="icon-shield" style="color: #0186d1"></i> Popup</a></li><li><a href="Portal.html"><i class="icon-shield" style="color: #0186d1"></i> Portal</a></li><li><a href="Proxy.html"><i class="icon-shield" style="color: #0186d1"></i> Proxy</a></li><li><a href="Radiobutton.html"><i class="icon-shield" style="color: #0186d1"></i> Radiobutton</a></li><li><a href="Reader.html"><i class="icon-shield" style="color: #0186d1"></i> Reader</a></li><li><a href="Selectbox.html"><i class="icon-shield" style="color: #0186d1"></i> Selectbox</a></li><li><a href="Site.html"><i class="icon-shield" style="color: #0186d1"></i> Site</a></li><li><a href="Sites.html"><i class="icon-shield" style="color: #0186d1"></i> Sites</a></li><li><a href="Store.html"><i class="icon-shield" style="color: #0186d1"></i> Store</a></li><li><a href="TabPanel.html"><i class="icon-shield" style="color: #0186d1"></i> TabPanel</a></li><li><a href="TDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> TDIApplet</a></li><li><a href="Testbench.html"><i class="icon-shield" style="color: #0186d1"></i> Testbench</a></li><li><a href="Testlet.html"><i class="icon-shield" style="color: #0186d1"></i> Testlet</a></li><li><a href="Textbox.html"><i class="icon-shield" style="color: #0186d1"></i> Textbox</a></li><li><a href="Toolbox.html"><i class="icon-shield" style="color: #0186d1"></i> Toolbox</a></li><li><a href="Trigger.html"><i class="icon-shield" style="color: #0186d1"></i> Trigger</a></li><li><a href="Triggers.html"><i class="icon-shield" style="color: #0186d1"></i> Triggers</a></li><li><a href="User.html"><i class="icon-shield" style="color: #0186d1"></i> User</a></li><li><a href="Users.html"><i class="icon-shield" style="color: #0186d1"></i> Users</a></li><li><a href="Violation.html"><i class="icon-shield" style="color: #0186d1"></i> Violation</a></li><li><a href="Widget.html"><i class="icon-shield" style="color: #0186d1"></i> Widget</a></li><li><a href="WindowManager.html"><i class="icon-shield" style="color: #0186d1"></i> WindowManager</a></li><li><a href="Workbench.html"><i class="icon-shield" style="color: #0186d1"></i> Workbench</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Global</li><li><a href="global.html#_anchors"><i class="icon-globe" style="color: black;"></i> _anchors</a></li><li><a href="global.html#_form"><i class="icon-globe" style="color: black;"></i> _form</a></li><li><a href="global.html#_interact"><i class="icon-globe" style="color: black;"></i> _interact</a></li><li><a href="global.html#_marker"><i class="icon-globe" style="color: black;"></i> _marker</a></li><li><a href="global.html#_tabPanel"><i class="icon-globe" style="color: black;"></i> _tabPanel</a></li><li><a href="global.html#browse"><i class="icon-globe" style="color: black;"></i> browse</a></li><li><a href="global.html#draggable"><i class="icon-globe" style="color: black;"></i> draggable</a></li><li><a href="global.html#events"><i class="icon-globe" style="color: black;"></i> events</a></li><li><a href="global.html#initialize"><i class="icon-globe" style="color: black;"></i> initialize</a></li><li><a href="global.html#layout"><i class="icon-globe" style="color: black;"></i> layout</a></li><li><a href="global.html#logger"><i class="icon-globe" style="color: black;"></i> logger</a></li><li><a href="global.html#login"><i class="icon-globe" style="color: black;"></i> login</a></li><li><a href="global.html#onDragstart"><i class="icon-globe" style="color: black;"></i> onDragstart</a></li><li><a href="global.html#onTabsActivate"><i class="icon-globe" style="color: black;"></i> onTabsActivate</a></li><li><a href="global.html#onTaskSelect"><i class="icon-globe" style="color: black;"></i> onTaskSelect</a></li><li><a href="global.html#perform"><i class="icon-globe" style="color: black;"></i> perform</a></li><li><a href="global.html#prepare"><i class="icon-globe" style="color: black;"></i> prepare</a></li><li><a href="global.html#requirejs"><i class="icon-globe" style="color: black;"></i> requirejs</a></li><li><a href="global.html#start"><i class="icon-globe" style="color: black;"></i> start</a></li><li><a href="global.html#toUrl"><i class="icon-globe" style="color: black;"></i> toUrl</a></li><li><a href="global.html#validate"><i class="icon-globe" style="color: black;"></i> validate</a></li></ul></div>
          </div>

          <div class="span8">
              <h1 class="page-header">Source: widget/Filebox.js</h1>
              


    
    <section>
        <article>
            <pre class="prettyprint source"><code>/**
 * @license
 * This document is a part of the source code and related artifacts
 * for uWeaver, an open source application development framework for
 * Enterprise Application Software.
 *
 *      http://www.uweaver.org
 *
 * Copyright 2014 Jason Lin
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

define(['jquery', 'underscore', 'uweaver/lang', 'uweaver/widget/Widget', 'uweaver/widget/Tooltips',
    'uweaver/exception/Violation'], function ($, _, lang, Widget, Tooltips, Violation){
    var declare = lang.declare;
    var Base = Widget;

    var VALIDATIONERRORS = {
        'valueMissing': null,
        'typeMismatch': 'type',
        'patternMismatch': 'pattern',
        'tooLong': 'maxLength',
        'tooShort': 'minLength',
        'rangeUnderFlow': 'min',
        'rangeOverflow': 'max',
        'stepMismatch': 'step',
        'badInput': null};

    /**
     * A Filebox is a widget for ....
     *
     * ##### JavaScript
     * ```javascript
     * var pictures = new Filebox({
     *     el: $('[name=pictures]')
     * });
     * pictures.render();
     *
     * expect(pictures.value()).to.be.instanceof(Array);
     * ```
     * ##### HTML
     * + selector: input[type=file].
     *
     * ```html
     * &lt;form name="form" class="container form-horizontal">
     * ...
     *  &lt;input type="file" name="pictures">
     * ...
     * &lt;/form>
     * ```
     * 
     * ##### Events:
     * + 'change' - [value()]{@link Filebox#value}, [add()]{@link Filebox#add}, [remove()]{@link Filebox#remove}
     *
     *
     * @constructor Filebox
     * @extends Widget
     * @author  Jason Lin
     * @since   1.0
     * @param {Object} [config] - A map of configuration to pass to the constructor.
     * @param {String} [config.value] - Specifies the value(files) of the filebox.
     * @param {Boolean} [config.multiple=false] - specifies that the user is allowed to enter more than one file in the filedropper.
     * @param {Boolean} [config.required=false] - Specifies that the filebox must have at least one file.
     * @param {Boolean} [config.disabled=false] - Specifies that the filebox should be disabled.
     * @param {Integer} [config.maxLength] - Specifies the maximum number of file allowed in the filebox.
     * @param {Integer} [config.minLength] - Specifies the minimum number of files allowed in the filebox.
     * @param {String} [config.chooseHandler] - Specifies the handler to invoke when file(s) chosen to upload.
     */
    function initialize(config) {
        Base.prototype.initialize.apply(this, arguments);
        var defaults = {};
        var cfg = this.cfg();

        _.defaults(cfg, defaults);

        this._items = [];

        this.$el.on("change", _.bind(onChange, this));


        var tooltips = new Tooltips({
            target: this
        }).render();

        this._tooltips = tooltips;

        (cfg.multiple!==undefined) &amp;&amp; this.multiple(cfg.multiple);
        (cfg.accept!==undefined) &amp;&amp; this.accept(cfg.accept);
        (cfg.required!==undefined) &amp;&amp; this.required(cfg.required);
        (cfg.maxLength!==undefined) &amp;&amp; this.maxLength(cfg.maxLength);
        (cfg.minLength!==undefined) &amp;&amp; this.minLength(cfg.minLength);
        (cfg.readonly!==undefined) &amp;&amp; this.readonly(cfg.readonly);
        (cfg.disabled!==undefined) &amp;&amp; this.disabled(cfg.disabled);


        this.clearValidation();

    }

    function onChange(event) {
        event.stopPropagation();
        event.preventDefault();

        this.choose(event.target.files);
    }

    /**
     * Get or set the handler to invoke when the user select the files to add.
     *
     * The files dropped are passed as the parameter and the handler should return the files to be stored.
     *
     * ##### JavaScript
     * ```javascript
     * var pictures = new Filedropper({
     *     el: $('[name=pictures]')
     * });
     *
     * function handler(files) {
     *      Date now = new Date();
     *
     *      _.each(files, function(file){
     *          file.dateAdded = now;
     *      });
     *
     *      return files;
     * }
     *
     * pictures.addHandler(handler);
     * ```
     *
     * @memberof Filedropper#
     * @param {Function} fn - The handler.
     * @returns {Function|void}
     */
    function chooseHandler(fn) {
        if(arguments.length===0) return this._chooseHandler;

        this._chooseHandler = fn;
    }

    /**
     * Add a file to the filedropper.
     *
     * ##### Events:
     * + 'change' - triggered after added. event.data => the files.
     *
     * @memberof Filedropper#
     * @param {File|Object} file - The file to add.
     * @param {Object} [options] - A map of additional options to pass to the method.
     * @param {Boolean} [options.selected=true] - A false value to prevent the new file from being selected.
     * @param {Boolean} [options.silent=false] - A true value will prevent the events from being triggered.
     * @returns {Filedropper} this
     */
    function add(item, options) {
        if(item===undefined) return this;

        var defaults = {
            index: this.size()
        };

        options || (options = {});

        _.defaults(options, defaults);

        item instanceof File &amp;&amp; (item.toJSON = fileToJSON);

        this._items.splice(options.index, 0, item);

        if(options.silent) return this;

        this.validate() &amp;&amp; this.change();

        return this;
    }

    /**
     * Remove a file to the filebox.
     *
     * ##### Events:
     * + 'change' - triggered after added. event.data => the files.
     *
     * @memberof Filebox#
     * @param {File|Object|Integer} file - The file(or index of file) to remove.
     * @param {Object} [options] - A map of additional options to pass to the method.
     * @param {Boolean} [options.silent=false] - A true value will prevent the events from being triggered.
     * @returns {Filedropper} this
     */
    function remove(item, options) {
        options || (options = {});

        var index = _.isNumber(item) ? item : _.findIndex(this.value(), function(n) {
            return n === item;
        });

        if(!index &amp;&amp; index!==0) return;

        this._items.splice(index, 1);

        options.silent || this.change();

        return this;
    }

    function removeAll(options) {
        options || (options = {});

        if(this.size()===0) return;

        this._items = [];

        options.silent || this.change();

        return this;
    }

    /**
     * Get the file.
     *
     * @memberof Filebox#
     * @param {Integer} index - The index of file. zero-based.
     * @returns {File}
     */
    function get(index) {
        if(!index &amp;&amp; index!==0) return;

        if(index>this.size() || index&lt;0) return null;

        return this._items[index];
    }


    function size() {
        return this._items.length;
    }

    function value(items, options) {
        options || (options = {});
        
        if(arguments.length===0) {
            if(this.multiple()) {
                return (this.size()===0) ? null : this._items;
            } else {
                return (this.size()===0) ? null : _.first(this._items);
            }
        }

        items || (items = []);

        _.isArray(items) || (items = [items]);

        if(equals.call(this, items)) return;

        _.each(items, function(item) {
            item instanceof File &amp;&amp; (item.toJSON = fileToJSON);
        });

        this._items = items;

        this.validate() &amp;&amp; (options.silent || this.change());
    }

    function clear() {
        var $input = this.$el;

        $input.val(null);

        this._items = [];

        this.clearValidation();
    }

    function equals(items) {
        return JSON.stringify(items) === JSON.stringify(this._items);
    }

    function fileToJSON() {
        var json = {};

        _.each(this, function(value, key) {
            json[key] = value;
        });

        json.name = this.name;
        json.type = this.type;
        json.size = this.size;

        return json;
    }

    function change() {
        this.trigger('change', {
            data: this.value(),
            context: this,
            source: this
        });
    }

    function choose(files) {
        this.chooseHandler() &amp;&amp; (files = this.chooseHandler()(files));

        if(!files||files.length===0) return;

        // append or replace?
        this.removeAll();

        if(this.multiple()) {
            if(this.size() + files.length > this.maxLength()) {
                return;
            }
        } else {
            ;
        }

        _.each(files, function(file) {
            this.add(file, {silent: true});
        }, this);

        this.trigger('choose', {
            data: files,
            context: this,
            source: this
        });

        this.render();

        this.validate() &amp;&amp; this.change();
    }

    function name(name) {

        if(!name) return this.$el.attr('name');

        this.$el.attr('name', name);
    }

    function type() {
        var $component = this.$el;

        return $component.attr('type');
    }

    function clearValidation() {
        this._violations = [];
        this._tooltips.content("");
        this.removeClass('uw-border-warn');
    }

    function readonly(value) {
        if(arguments.length===0) return this.el.hasAttribute('readonly');

        if(value) {
            this.el.setAttribute('readonly', null);
        } else {
            this.el.removeAttribute('readonly');
        }
    }

    function required(value) {
        if(arguments.length===0) return this.el.hasAttribute('required');

        value ? this.el.setAttribute('required', null) : this.el.removeAttribute('required');
    }

    function disabled(value) {
        if(arguments.length===0) return this.el.hasAttribute('disabled');

        if(value) {
            this.el.setAttribute('disabled', null);
        } else {
            this.el.removeAttribute('disabled');
        }
    }

    function maxLength(value) {
        var $component = this.$el;

        if(arguments.length===0) {
            if(!this.el.hasAttribute('multiple')) return 1;

            var value = Number($component.attr('maxLength'));

            return value;
        }

        $component.attr('maxLength', value);
    }

    function minLength(value) {
        var $component = this.$el;
        if(arguments.length===0) return Number($component.attr('minLength'));
        $component.attr('minLength', value);
    }

    function multiple(value) {
        if(arguments.length===0) return this.el.hasAttribute('multiple');

        value ? this.el.setAttribute('multiple', null) : this.el.removeAttribute('multiple');
    }

    function accept(value) {
        var $component = this.$el;
        if(arguments.length===0) return $component.attr('accept');
        $component.attr('accept', value);
    }

    /**
     * Validate the value of the inputbox.
     */
    function validate() {
        var $control = this.$el;
        var validity = $control.prop('validity');
        var valid = true;

        this.clearValidation();

        (valid &amp;&amp; _.isObject(validity)) &amp;&amp; (valid = this.checkValidity());

        (valid &amp;&amp; this.useCustomType()) &amp;&amp; (valid = this.customValidate());

        return valid;
    }

    function checkValidity() {
        var $input = this.$el;
        var validity = $input.prop('validity');

        if(!validity.valid) {
            _.each(VALIDATIONERRORS, function(prop, error) {
                if(validity[error]) {
                    var parameters = [];
                    if(prop) {
                        parameters.push($input.prop(prop)||$input.attr(prop));
                    }
                    this.violate(new Violation({
                        properties: [this.name()],
                        error: error.toUpperCase(),
                        parameters: parameters
                    }));
                }
            }, this);

            var validationMessage = "";
            _.each(this._violations, function(violation) {
                validationMessage = validationMessage + '\n' + violation.toString();
            });
            $input.get(0).setCustomValidity(validationMessage);
        }


        return validity.valid;
    }

    function useCustomType() {
        return true;
    }

    function customValidate() {
        var valid = true;

        this.validateRequired() || (valid = false);
        this.validateMaxLength() || (valid = false);
        this.validateMinLength() || (valid = false);

        return valid;
    }

    function validateRequired() {
        if(!this.required()) return true;

        if(this.size()===0) {
            this.violate(new Violation({
                properties: [this.name()],
                error: Violation.Error.VALUEMISSING
            }));
            return false;
        }

        return true;
    }

    function validateMaxLength() {
        if(!this.maxLength()) return true;

        if(this.size()>this.maxLength()) {
            this.violate(new Violation({
                properties: [this.name()],
                error: Violation.Error.TOOLONG,
                parameters: [this.maxLength()]
            }));
            return false;
        }

        return true;
    }

    function validateMinLength() {
        if(!this.minLength()) return true;

        if(this.size()&lt;this.minLength()) {
            this.violate(new Violation({
                properties: [this.name()],
                error: Violation.Error.TOOSHORT,
                parameters: [this.minLength()]
            }));
            return false;
        }

        return true;
    }

    function violate(violation) {
        if(!violation) return;

        this._violations.push(violation);

        this.hasClass('uw-border-warn') || this.addClass('uw-border-warn');

        this._tooltips.append(violation.toString() + "&lt;br>");

        return violation;
    }


    function violations() {
        return this._violations;
    }

    function state(value) {
        if(arguments.length===0) return this._state;

        this._state = value.toUpperCase();

        this.readonlyState() &amp;&amp; this.readonly(_.contains(this.readonlyState().toUpperCase().split(","), this._state));
        this.disabledState() &amp;&amp; this.disabled(_.contains(this.disabledState().toUpperCase().split(","), this._state));
        this.hiddenState() &amp;&amp; _.contains(this.hiddenState().toUpperCase().split(","), this._state) ? this.hide() : this.show();
    }

    function readonlyState(value) {
        var $input = this.$el;
        if(arguments.length===0) return $input.attr('data-readonly-state');
        $input.attr('data-readonly-state', value);
    }

    function disabledState(value) {
        var $input = this.$el;
        if(arguments.length===0) return $input.attr('data-disabled-state');
        $input.attr('data-disabled-state', value);
    }

    function hiddenState(value) {
        var $input = this.$el;
        if(arguments.length===0) return $input.attr('data-hidden-state');
        $input.attr('data-hidden-state', value);
    }
    /**
     * @todo
     * @param hint
     * @returns {*}
     */
    function placeholder(hint) {
    }

    var props = {
        _items: undefined,
        _index: undefined,
        _addHandler: undefined,
        _rest: undefined,
        _state: undefined
    };

    var Filebox = declare(Base, {
        initialize: initialize,
        value: value,
        clear: clear,
        size: size,
        add: add,
        remove: remove,
        removeAll: removeAll,
        choose: choose,
        name: name,
        type: type,
        placeholder: placeholder,
        validate: validate,
        violate: violate,
        violations: violations,
        checkValidity: checkValidity,
        useCustomType: useCustomType,
        customValidate: customValidate,
        clearValidation: clearValidation,
        validateRequired: validateRequired,
        validateMaxLength: validateMaxLength,
        validateMinLength: validateMinLength,
        multiple: multiple,
        readonly: readonly,
        required: required,
        disabled: disabled,
        maxLength: maxLength,
        minLength: minLength,
        accept: accept,
        state: state,
        readonlyState: readonlyState,
        disabledState: disabledState,
        hiddenState: hiddenState,
        change: change,
        chooseHandler: chooseHandler
    }, props);

    return Filebox;
});</code></pre>
        </article>
    </section>




          </div>
      </div>

        <br clear="both">

      <footer>
        Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.3.2</a> on Fri Aug 26 2016 10:58:19 GMT+0800 (CST)
        <br>
      </footer>
      <script> prettyPrint(); </script>
    </div>
  </body>
</html>
